pub fn execute_task01(content: &str) {
    let iter = content.lines()
        .map(|line| line.to_string());
    let calibration = sum_lines(iter);

    assert_eq!(calibration, 56465);
    println!("Day01 - Task01 - Calibration: {}", calibration)
}


pub fn execute_task02(content: &str) {
    let iter = content.lines()
        .map(|line| {
            let mut full_str = String::new();
            for char in line.chars() {
                full_str.push(char);

                let copy = full_str.replace("one", "1")
                    .replace("two", "2")
                    .replace("three", "3")
                    .replace("four", "4")
                    .replace("five", "5")
                    .replace("six", "6")
                    .replace("seven", "7")
                    .replace("eight", "8")
                    .replace("nine", "9");

                if copy != full_str {
                    full_str = copy;
                    full_str.push(char);
                }
            }

            full_str
        });

    let calibration = sum_lines(iter);

    assert_eq!(calibration, 55902);
    println!("Day01 - Task02 - Calibration: {}", calibration)
}

fn sum_lines(iter: impl Iterator<Item=String>) -> i32 {
    iter
    .map(|line| format!("{}{}",
                        line.matches(|c: char| c.is_ascii_digit()).next().unwrap(),
                        line.rmatches(|c: char| c.is_ascii_digit()).next().unwrap()))
    .map(|number_str| number_str.parse::<i32>().unwrap())
    .sum()
}